--- /dev/null	2014-06-08 16:48:21.619993950 +0100
+++ split.c	2014-06-08 20:49:46.585346862 +0100
@@ -0,0 +1,74 @@
+void vsplit( Monitor * m, Bool check );
+void hsplit( Monitor * m, Bool check );
+
+void vsplit( Monitor * m, Bool check ) {
+	unsigned int windows = 0;
+	for( Client * c = nexttiled( m->clients ); c != NULL; c = nexttiled( c->next ) )
+		windows++;
+	if( windows == 0 )
+		return;
+	if( check && windows == 2 ) {
+		hsplit( m, False );
+		return;
+	}
+
+	const unsigned int rows = windows / 2 + windows % 2;
+	const unsigned int width = m->ww / 2;
+	const unsigned int height = m->wh / rows;
+
+	unsigned int curr = 0;
+	for( Client * c = nexttiled( m->clients ); c != NULL; c = nexttiled( c->next ) ) {
+		resize(
+			c,
+			curr % 2 == 0 ? 0 : width,
+			( curr / 2 ) * height,
+			windows % 2 == 1 && curr + 1 == windows ? m->ww : width - ( 1 - curr % 2 ),
+			( curr / 2 ) == rows - 1 ? m->wh - ( rows - 1 ) * height : height - 1,
+			False
+		);
+
+		curr++;
+	}
+
+}
+
+void hsplit( Monitor * m, Bool check ) {
+	unsigned int windows = 0;
+	for( Client * c = nexttiled( m->clients ); c != NULL; c = nexttiled( c->next ) )
+		windows++;
+	if( windows == 0 )
+		return;
+	if( check && windows == 2 ) {
+		vsplit( m, False );
+		return;
+	}
+
+	const unsigned int cols = windows / 2 + windows % 2;
+	const unsigned int width = m->ww / cols;
+	const unsigned int height = m->wh / 2;
+
+	unsigned int curr = 0;
+	for( Client * c = nexttiled( m->clients ); c != NULL; c = nexttiled( c->next ) ) {
+		const unsigned int rel = windows % 2 == 1 && curr > 0 ? curr + 1 : curr;
+
+		resize(
+			c,
+			( rel / 2 ) * width,
+			rel % 2 == 0 ? 0 : height,
+			( rel / 2 ) == cols - 1 ? m->ww - ( cols - 1 ) * width : width - 1,
+			windows == 1 || ( windows % 2 == 1 && curr == 0 ) ? m->wh : rel % 2 == 0 ? height - 1 : m->wh - height,
+			False
+		);
+
+		curr++;
+	}
+
+}
+
+void layout_hsplit( Monitor * m ) {
+	hsplit( m, True );
+}
+
+void layout_vsplit( Monitor * m ) {
+	vsplit( m, True );
+}
